#!/usr/bin/env python
# vim: set fileencoding=UTF-8 :
#############################################################
#############################################################
# Auto Drive
# Author: Can Kosar
#############################################################

#Standard libraries
import sys

#Custom libraries
sys.path.append("../lib/")
import l_drive
import l_odo
import time

#Odometry
odo=l_odo.odo_asynch() #Define object
odo.start(False) #Start measuring with the frequency
#Drive       
drive=l_drive.drive()
drive.move_fw(70,12)

while True:
    print "t=%.6f\tleft=%.6f(%d)\tright=%.6f(%d)"%(odo.t_label.value,odo.rad_to_arc(odo.enc_l.value),odo.enc_l.value,odo.rad_to_arc(odo.enc_r.value),odo.enc_r.value)
    time.sleep(0.1)










# 
# 
# 
# #events=OrderedDict([("move_fw(70)",1),("move_bw(70)",1),("turn_right(70)",1),("turn_left(70)",1),("break_move()",1)])
# events=OrderedDict([("move_fw(70,18)",4),("break_move()",1)])
# 
# drive=l_drive.drive()
# 
# t0=datetime.now()
# i_event=1
# event_edge=sum(events.values()[0:i_event])
# arr_t=[]
# arr_enc_l=[]
# arr_enc_r=[]
# arr_yaw=[]
# enc_l=0
# enc_r=0
# enc_l_flag=True
# enc_r_flag=True
# border=0.5
# ##############################################
# while True:
#     
#     now=datetime.now()            
#     delta=now-t0
#     tx=delta.seconds + delta.microseconds/1E6
# 
# ##############################################
# #               Events
# ##############################################
#     if tx>=event_edge:
#         i_event+=1
#         event_edge=sum(events.values()[0:i_event])
# 
#     if i_event<=len(events.keys()):
#         funceval=events.keys()[i_event-1]
#         eval("drive."+funceval)
#         if "move_fw" in funceval:
#             right_sign=1
#             left_sign=1
#         elif "move_bw" in funceval:
#             right_sign=-1
#             left_sign=-1
#         if "turn_right" in funceval:
#             right_sign=-1
#             left_sign=1
#         elif "turn_left" in funceval:
#             right_sign=1
#             left_sign=-1
#         
#     else:
#         break
#     
#     ##################################################################
#     #Odometry
#     ##################################################################
#     arr_t.append(tx)
#     c1=float(enc_1.read_data())
#     c2=float(enc_2.read_data())
#     c1/=1024
#     c2/=1024
#     if (enc_l_flag and c1<border) or (not enc_l_flag and c1>border):        
#         enc_l+=1*left_sign
#         enc_l_flag=not enc_l_flag       
#         
#     if (enc_r_flag and c2<border) or (not enc_r_flag and c2>border):        
#         enc_r+=1*right_sign
#         enc_r_flag=not enc_r_flag  
#         
#     arr_enc_l.append(enc_l)
#     arr_enc_r.append(enc_r)
#     #time.sleep(0.1)
#   
# ######################################################################################################################  
# # Coordinate prediction       
# #######################################################################################################################
# 
# c_arc=92./182.
# l_arc_l=enc_l*c_arc
# l_arc_r=enc_r*c_arc
# 
# 
# 
# 
# 
# 
# print "Left encoder: %d \tRight encoder: %d\tLeft arc: %.3f \tRight arc: %.3f" %(enc_l,enc_r,l_arc_l,l_arc_r)
# 
# # l_misc.plots().write_gnu_file("odometry.dat",[arr_t,arr_enc_l,arr_enc_r],"%.6f")
# # os.system("gnuplot -e \"plot  'odometry.dat' using 1:2 with lines, 'odometry.dat' using 1:3 with lines,'odometry.dat' using 1:4 with lines, 'odometry.dat' using 1:5 with lines;pause -1\"")
#         