import time
import math
import sys
import os
from datetime import datetime
from time import sleep

sys.path.append("../lib/")
#Import compass library
import l_accel
# Sensor initialization
mpu = l_accel.MPU6050()
mpu.dmpInitialize()
mpu.setDMPEnabled(True)

# print mpu.getXGyroOffset()
# print mpu.getYGyroOffset()
# print mpu.getZGyroOffset()
#  
# mpu.setXGyroOffsetUser(0)
# mpu.setYGyroOffsetUser(0)
# mpu.setZGyroOffsetUser(0)
#sys.exit()
# while True:
#     datahash=mpu.get_hash()
#     if datahash:
#          
#         g=datahash['g']
#         q=datahash['q']
#         ypr = mpu.dmpGetYawPitchRoll(q, g)
#         print "ax: %.6f \t ay: %.6f \t az: %.6f" %(g['x'],g['y'],g['z'])
#         print "yaw: %.6f \t pitch: %.6f \t roll: %.6f" %(ypr['yaw']*180/math.pi,ypr['pitch']*180/math.pi,ypr['roll']*180/math.pi)
#         
#    













################################################################################
def write_gnu_file(filename,x,y):
    
    hash="#X\tY\n"
    for i in range(len(x)):
        hash=hash+"%.3f\t%.3f\n"%(x[i],y[i])
    gnufile= open(filename,"w")
    gnufile.write(hash)
    
    

pre_settle=1
break_time=pre_settle+30
after_break_time=break_time+3
t0=datetime.now()
x0=0
v0=0
a0=0
t=[]
x=[x0]
v=[v0]
a=[]     

cal_ax=-0.008
cal_ay=-0.008
while True:
            
    now=datetime.now()
    
    delta=now-t0
    tx=delta.seconds + delta.microseconds/1E6
    #print tx
    datahash=mpu.get_hash()

    if datahash:                 
        ax=(datahash['g']['y']+cal_ax)
        print ax
        
        t.append(tx)
        a.append(ax)
    if tx>break_time and tx<after_break_time:
        #drive.break_move()
        pass
    elif tx>after_break_time:
        break
    elif tx>pre_settle:
        #drive.move_fw(100,0)
        pass
write_gnu_file("acc.dat", t, a)
os.system("gnuplot -persist -e \"plot  'acc.dat' with lines using 1:2 ;pause -1\"")
        
        
