#!/usr/bin/python



#Standard libraries
import sys
import os
import time
import math
import numpy as np
import matplotlib.pyplot as plt
# from scipy import integrate
#Custom libraries
sys.path.append("../lib/")
import l_misc

#Pickle
import pickle
from signal import signal, SIGPIPE, SIG_DFL
signal(SIGPIPE,SIG_DFL) 




r=0.15
p=[0,0,0,0,0]
p[0]=np.matrix([0,-r,-math.pi/2.]).transpose()
p[1]=np.matrix([r*math.sqrt(2)/2.,-r*math.sqrt(2)/2.,-math.pi/4.]).transpose()
p[2]=np.matrix([r,0,0]).transpose()
p[3]=np.matrix([r*math.sqrt(2)/2.,r*math.sqrt(2)/2.,math.pi/4.]).transpose()
p[4]=np.matrix([0,r,math.pi/2.]).transpose() 

with open("map_hash.dat", 'rb') as f:
    map_hash = pickle.load(f)
    
    
trans=l_misc.translate_ref()


pts=[[] for i in range(5)]
#i=map_hash[10]

for i in map_hash[5:]:
    
    state=i["state"]
#     print "state",state
#     print "measurement",i["us"]
    for j in range(len(i["us"])):
        us=i["us"][j]
        us=0
        vector=np.matrix([us/100.,0,0]).transpose()
    #     print "vector",vector
        v_in_device=trans.local_to_global(p[j],vector)
    #     print "In device",v_in_device
        v_global=trans.local_to_global(state,v_in_device)
        
#         if not j in pts:
#             pts[j]=[]
        pts[j].append(v_global[0:2,:].transpose().tolist()[0])

#print pts

for j in pts:
    arr=np.matrix(j)
    plt.plot(arr[:,0],arr[:,1])
    #plt.plot(arr_t,arr_2)
    #plt.plot(arr_t,arr_f)

    plt.show()